Index: trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.dsp
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.dsp	(revision 12)
+++ trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.dsp	(revision 14)
@@ -1,3 +1,3 @@
-# Microsoft Developer Studio Project File - Name="Plugin_BSPSceneManager" - Package Owner=<4>
+# Microsoft Developer Studio Project File - Name="Plugin_OcclusionCullingSceneManager" - Package Owner=<4>
 # Microsoft Developer Studio Generated Build File, Format Version 6.00
 # ** DO NOT EDIT **
@@ -5,19 +5,19 @@
 # TARGTYPE "Win32 (x86) Dynamic-Link Library" 0x0102
 
-CFG=Plugin_BSPSceneManager - Win32 Debug
+CFG=Plugin_OcclusionCullingSceneManager - Win32 Debug
 !MESSAGE This is not a valid makefile. To build this project using NMAKE,
 !MESSAGE use the Export Makefile command and run
 !MESSAGE 
-!MESSAGE NMAKE /f "Plugin_BSPSceneManager.mak".
+!MESSAGE NMAKE /f "Plugin_OcclusionCullingSceneManager.mak".
 !MESSAGE 
 !MESSAGE You can specify a configuration when running NMAKE
 !MESSAGE by defining the macro CFG on the command line. For example:
 !MESSAGE 
-!MESSAGE NMAKE /f "Plugin_BSPSceneManager.mak" CFG="Plugin_BSPSceneManager - Win32 Debug"
+!MESSAGE NMAKE /f "Plugin_OcclusionCullingSceneManager.mak" CFG="Plugin_OcclusionCullingSceneManager - Win32 Debug"
 !MESSAGE 
 !MESSAGE Possible choices for configuration are:
 !MESSAGE 
-!MESSAGE "Plugin_BSPSceneManager - Win32 Release" (based on "Win32 (x86) Dynamic-Link Library")
-!MESSAGE "Plugin_BSPSceneManager - Win32 Debug" (based on "Win32 (x86) Dynamic-Link Library")
+!MESSAGE "Plugin_OcclusionCullingSceneManager - Win32 Release" (based on "Win32 (x86) Dynamic-Link Library")
+!MESSAGE "Plugin_OcclusionCullingSceneManager - Win32 Debug" (based on "Win32 (x86) Dynamic-Link Library")
 !MESSAGE 
 
@@ -30,5 +30,5 @@
 RSC=rc.exe
 
-!IF  "$(CFG)" == "Plugin_BSPSceneManager - Win32 Release"
+!IF  "$(CFG)" == "Plugin_OcclusionCullingSceneManager - Win32 Release"
 
 # PROP BASE Use_MFC 0
@@ -43,6 +43,6 @@
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /MT /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PLUGIN_BSPSCENEMANAGER_EXPORTS" /YX /FD /c
-# ADD CPP /nologo /MD /W3 /GX /O2 /I "..\include" /I "..\..\..\OgreMain\include" /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PLUGIN_BSPSCENEMANAGER_EXPORTS" /YX /FD /c
+# ADD BASE CPP /nologo /MT /W3 /GX /O2 /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PLUGIN_OCCLUSIONCULLINGSCENEMANAGER_EXPORTS" /YX /FD /c
+# ADD CPP /nologo /MD /W3 /GX /O2 /I "..\include" /I "..\..\..\..\..\ogrenew\OgreMain\include" /D "WIN32" /D "NDEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PLUGIN_OCCLUSIONCULLINGSCENEMANAGER_EXPORTS" /YX /FD /c
 # ADD BASE MTL /nologo /D "NDEBUG" /mktyplib203 /win32
 # ADD MTL /nologo /D "NDEBUG" /mktyplib203 /win32
@@ -54,11 +54,12 @@
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /dll /machine:I386
-# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib OgreMain.lib /nologo /dll /machine:I386 /libpath:"..\..\..\OgreMain\lib\Release"
+# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib OgreMain.lib /nologo /dll /machine:I386 /libpath:"..\..\..\..\..\ogrenew\OgreMain\lib\Release"
+# SUBTRACT LINK32 /pdb:none
 # Begin Special Build Tool
 SOURCE="$(InputPath)"
-PostBuild_Cmds=copy ..\bin\Release\*.dll ..\..\..\Samples\Common\bin\Release
+PostBuild_Cmds=copy ..\bin\Release\*.dll ..\..\..\..\..\ogrenew\Samples\Common\bin\Release
 # End Special Build Tool
 
-!ELSEIF  "$(CFG)" == "Plugin_BSPSceneManager - Win32 Debug"
+!ELSEIF  "$(CFG)" == "Plugin_OcclusionCullingSceneManager - Win32 Debug"
 
 # PROP BASE Use_MFC 0
@@ -73,6 +74,6 @@
 # PROP Ignore_Export_Lib 0
 # PROP Target_Dir ""
-# ADD BASE CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PLUGIN_BSPSCENEMANAGER_EXPORTS" /YX /FD /GZ /c
-# ADD CPP /nologo /MDd /W3 /Gm /GX /ZI /Od /I "..\include" /I "..\..\..\OgreMain\include" /D "WIN32" /D "_DEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PLUGIN_BSPSCENEMANAGER_EXPORTS" /YX /FD /GZ /Zm200 /c
+# ADD BASE CPP /nologo /MTd /W3 /Gm /GX /ZI /Od /D "WIN32" /D "_DEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PLUGIN_OCCLUSIONCULLINGSCENEMANAGER_EXPORTS" /YX /FD /GZ /c
+# ADD CPP /nologo /MDd /W3 /Gm /GX /ZI /Od /I "..\include" /I "..\..\..\..\..\ogrenew\OgreMain\include" /D "WIN32" /D "_DEBUG" /D "_WINDOWS" /D "_MBCS" /D "_USRDLL" /D "PLUGIN_OCCLUSIONCULLINGSCENEMANAGER_EXPORTS" /YX /FD /GZ /Zm200 /c
 # ADD BASE MTL /nologo /D "_DEBUG" /mktyplib203 /win32
 # ADD MTL /nologo /D "_DEBUG" /mktyplib203 /win32
@@ -84,8 +85,9 @@
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /dll /debug /machine:I386 /pdbtype:sept
-# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib OgreMain_d.lib /nologo /dll /debug /machine:I386 /pdbtype:sept /libpath:"..\..\..\OgreMain\lib\Debug"
+# ADD LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib OgreMain_d.lib /nologo /dll /debug /machine:I386 /pdbtype:sept /libpath:"..\..\..\..\..\ogrenew\OgreMain\lib\Debug"
+# SUBTRACT LINK32 /pdb:none
 # Begin Special Build Tool
 SOURCE="$(InputPath)"
-PostBuild_Cmds=copy ..\bin\Debug\*.dll ..\..\..\Samples\Common\bin\Debug
+PostBuild_Cmds=copy ..\bin\Debug\*.dll ..\..\..\..\..\ogrenew\Samples\Common\bin\Debug
 # End Special Build Tool
 
@@ -94,6 +96,6 @@
 # Begin Target
 
-# Name "Plugin_BSPSceneManager - Win32 Release"
-# Name "Plugin_BSPSceneManager - Win32 Debug"
+# Name "Plugin_OcclusionCullingSceneManager - Win32 Release"
+# Name "Plugin_OcclusionCullingSceneManager - Win32 Debug"
 # Begin Group "Source Files"
 
@@ -101,41 +103,17 @@
 # Begin Source File
 
-SOURCE=..\src\OgreBspLevel.cpp
+SOURCE=..\src\OgreOcclusionCullingResourceManager.cpp
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\OgreBspNode.cpp
+SOURCE=..\src\OgreOcclusionCullingSceneManager.cpp
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\OgreBspResourceManager.cpp
+SOURCE=..\misc\OgreOcclusionCullingSceneManager.def
 # End Source File
 # Begin Source File
 
-SOURCE=..\src\OgreBspSceneManager.cpp
-# End Source File
-# Begin Source File
-
-SOURCE=..\misc\OgreBspSceneManager.def
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\OgreBspSceneManagerDll.cpp
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\OgreBspSceneNode.cpp
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\OgreQuake3Level.cpp
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\OgreQuake3Shader.cpp
-# End Source File
-# Begin Source File
-
-SOURCE=..\src\OgreQuake3ShaderManager.cpp
+SOURCE=..\src\OgreOcclusionCullingSceneManagerDll.cpp
 # End Source File
 # End Group
@@ -145,41 +123,9 @@
 # Begin Source File
 
-SOURCE=..\include\OgreBspLevel.h
+SOURCE=..\include\OgreOcclusionCullingResourceManager.h
 # End Source File
 # Begin Source File
 
-SOURCE=..\include\OgreBspNode.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\OgreBspPrerequisites.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\OgreBspResourceManager.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\OgreBspSceneManager.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\OgreBspSceneNode.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\OgreQuake3Level.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\OgreQuake3Shader.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\OgreQuake3ShaderManager.h
-# End Source File
-# Begin Source File
-
-SOURCE=..\include\OgreQuake3Types.h
+SOURCE=..\include\OgreOcclusionCullingSceneManager.h
 # End Source File
 # End Group
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.dsw
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.dsw	(revision 14)
+++ trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.dsw	(revision 14)
@@ -0,0 +1,29 @@
+Microsoft Developer Studio Workspace File, Format Version 6.00
+# WARNING: DO NOT EDIT OR DELETE THIS WORKSPACE FILE!
+
+###############################################################################
+
+Project: "Plugin_OcclusionCullingSceneManager"=.\Plugin_OcclusionCullingSceneManager.dsp - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+}}}
+
+###############################################################################
+
+Global:
+
+Package=<5>
+{{{
+}}}
+
+Package=<3>
+{{{
+}}}
+
+###############################################################################
+