Index: trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.vcproj
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.vcproj	(revision 13)
+++ trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.vcproj	(revision 16)
@@ -20,5 +20,5 @@
 				Name="VCCLCompilerTool"
 				Optimization="0"
-				AdditionalIncludeDirectories="..\include;$(OGRE_PATH)\OgreMain\include"
+				AdditionalIncludeDirectories="..\include; $(OGRE_PATH)\OgreMain\include"
 				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;_USRDLL;PLUGIN_OCCLUSIONCULLINGSCENEMANAGER_EXPORTS"
 				MinimalRebuild="TRUE"
@@ -51,5 +51,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(OutDir)\$(TargetFileName) ..\..\..\Samples\Common\bin\$(ConfigurationName)"/>
+				CommandLine="copy $(OutDir)\$(TargetFileName) $(OGRE_PATH)\Samples\Common\bin\$(ConfigurationName)"/>
 			<Tool
 				Name="VCPreBuildEventTool"/>
@@ -87,5 +87,5 @@
 				EnableFiberSafeOptimizations="TRUE"
 				OptimizeForProcessor="2"
-				AdditionalIncludeDirectories="..\include;..\..\..\OgreMain\include"
+				AdditionalIncludeDirectories="..\include;$(OGRE_PATH)\OgreMain\include"
 				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;PLUGIN_OCCLUSIONCULLINGSCENEMANAGER_EXPORTS"
 				StringPooling="TRUE"
@@ -107,5 +107,5 @@
 				LinkIncremental="1"
 				SuppressStartupBanner="TRUE"
-				AdditionalLibraryDirectories="&quot;..\..\..\OgreMain\lib\$(ConfigurationName)&quot;;&quot;..\..\..\Dependencies\lib\$(ConfigurationName)&quot;"
+				AdditionalLibraryDirectories="&quot;$(OGRE_PATH)\OgreMain\lib\$(ConfigurationName)&quot;;&quot;..\..\..\Dependencies\lib\$(ConfigurationName)&quot;"
 				ModuleDefinitionFile="..\misc\OgreOcclusionCullingSceneManager.def"
 				GenerateDebugInformation="TRUE"
@@ -119,5 +119,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(OutDir)\$(TargetFileName) ..\..\..\Samples\Common\bin\$(ConfigurationName)"/>
+				CommandLine="copy $(OutDir)\$(TargetFileName) $(OGRE_PATH)\Samples\Common\bin\$(ConfigurationName)"/>
 			<Tool
 				Name="VCPreBuildEventTool"/>
@@ -153,4 +153,7 @@
 				RelativePath="..\src\OgreOcclusionCullingSceneManagerDll.cpp">
 			</File>
+			<File
+				RelativePath="..\TestCulling\TestCullingApplication.cpp">
+			</File>
 		</Filter>
 		<Filter
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.sln
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.sln	(revision 12)
+++ trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.sln	(revision 16)
@@ -6,4 +6,5 @@
 Project("{8BC9CEB8-8B4A-11D0-8D11-00A0C91BC942}") = "TestCulling", "..\TestCulling\TestCulling.vcproj", "{248F19A6-2FE0-4F5D-8928-E0EA10609887}"
 	ProjectSection(ProjectDependencies) = postProject
+		{80DECC17-BDDD-4412-8CF8-F7C1C17A7436} = {80DECC17-BDDD-4412-8CF8-F7C1C17A7436}
 	EndProjectSection
 EndProject
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/Plugins.cfg
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/Plugins.cfg	(revision 12)
+++ 	(revision )
@@ -1,18 +1,0 @@
-# Defines plugins to load
-
-# Define plugin folder
-PluginFolder=.
-
-# Define plugins
-Plugin=RenderSystem_Direct3D7
-Plugin=RenderSystem_Direct3D9
-Plugin=RenderSystem_GL
-Plugin=Plugin_FileSystem
-Plugin=Plugin_ParticleFX
-# Plugin=Plugin_BSPSceneManager
-Plugin=Plugin_OctreeSceneManager
-Plugin=Plugin_GuiElements
-Plugin=Plugin_NatureSceneManager
-Plugin=Plugin_CgProgramManager
-Plugin=Plugin_OcclusionCullingSceneManager
-
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.vcproj.old
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.vcproj.old	(revision 12)
+++ 	(revision )
@@ -1,204 +1,0 @@
-<?xml version="1.0" encoding = "windows-1250"?>
-<VisualStudioProject
-	ProjectType="Visual C++"
-	Version="7.00"
-	Name="Plugin_BSPSceneManager"
-	ProjectGUID="{80DECC17-BDDD-4412-8CF8-F7C1C17A7436}"
-	Keyword="Win32Proj">
-	<Platforms>
-		<Platform
-			Name="Win32"/>
-	</Platforms>
-	<Configurations>
-		<Configuration
-			Name="Debug|Win32"
-			OutputDirectory="..\bin\$(ConfigurationName)"
-			IntermediateDirectory="..\obj\$(ConfigurationName)"
-			ConfigurationType="2"
-			CharacterSet="2">
-			<Tool
-				Name="VCCLCompilerTool"
-				Optimization="0"
-				AdditionalIncludeDirectories="..\include;..\..\..\OgreMain\include"
-				PreprocessorDefinitions="WIN32;_DEBUG;_WINDOWS;_USRDLL;PLUGIN_BSPSCENEMANAGER_EXPORTS"
-				MinimalRebuild="TRUE"
-				BasicRuntimeChecks="3"
-				RuntimeLibrary="3"
-				EnableFunctionLevelLinking="TRUE"
-				UsePrecompiledHeader="2"
-				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="4"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLinkerTool"
-				IgnoreImportLibrary="TRUE"
-				AdditionalDependencies="OgreMain_d.lib"
-				OutputFile="$(OutDir)/Plugin_BSPSceneManager.dll"
-				Version="0.99"
-				LinkIncremental="2"
-				SuppressStartupBanner="TRUE"
-				AdditionalLibraryDirectories="&quot;..\..\..\OgreMain\lib\$(ConfigurationName)&quot;;&quot;..\..\..\Dependencies\lib\$(ConfigurationName)&quot;"
-				ModuleDefinitionFile="..\misc\OgreBSPSceneManager.def"
-				GenerateDebugInformation="TRUE"
-				ProgramDatabaseFile="$(OutDir)/Plugin_BSPSceneManager.pdb"
-				SubSystem="2"
-				ImportLibrary="$(OutDir)/Plugin_BSPSceneManager.lib"
-				TargetMachine="1"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"
-				CommandLine="copy $(OutDir)\$(TargetFileName) ..\..\..\Samples\Common\bin\$(ConfigurationName)"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCWebDeploymentTool"/>
-		</Configuration>
-		<Configuration
-			Name="Release|Win32"
-			OutputDirectory="..\bin\$(ConfigurationName)"
-			IntermediateDirectory="..\obj\$(ConfigurationName)"
-			ConfigurationType="2"
-			CharacterSet="2"
-			WholeProgramOptimization="TRUE">
-			<Tool
-				Name="VCCLCompilerTool"
-				Optimization="3"
-				GlobalOptimizations="TRUE"
-				InlineFunctionExpansion="2"
-				EnableIntrinsicFunctions="TRUE"
-				ImproveFloatingPointConsistency="TRUE"
-				FavorSizeOrSpeed="1"
-				OmitFramePointers="TRUE"
-				EnableFiberSafeOptimizations="TRUE"
-				OptimizeForProcessor="2"
-				AdditionalIncludeDirectories="..\include;..\..\..\OgreMain\include"
-				PreprocessorDefinitions="WIN32;NDEBUG;_WINDOWS;_USRDLL;PLUGIN_BSPSCENEMANAGER_EXPORTS"
-				StringPooling="TRUE"
-				RuntimeLibrary="2"
-				BufferSecurityCheck="FALSE"
-				EnableFunctionLevelLinking="TRUE"
-				UsePrecompiledHeader="0"
-				WarningLevel="3"
-				Detect64BitPortabilityProblems="TRUE"
-				DebugInformationFormat="3"/>
-			<Tool
-				Name="VCCustomBuildTool"/>
-			<Tool
-				Name="VCLinkerTool"
-				IgnoreImportLibrary="TRUE"
-				AdditionalDependencies="OgreMain.lib"
-				OutputFile="$(OutDir)/Plugin_BSPSceneManager.dll"
-				Version="0.99"
-				LinkIncremental="1"
-				SuppressStartupBanner="TRUE"
-				AdditionalLibraryDirectories="&quot;..\..\..\OgreMain\lib\$(ConfigurationName)&quot;;&quot;..\..\..\Dependencies\lib\$(ConfigurationName)&quot;"
-				ModuleDefinitionFile="..\misc\OgreBSPSceneManager.def"
-				GenerateDebugInformation="TRUE"
-				SubSystem="2"
-				OptimizeReferences="2"
-				EnableCOMDATFolding="2"
-				ImportLibrary="$(OutDir)/Plugin_BSPSceneManager.lib"
-				TargetMachine="1"/>
-			<Tool
-				Name="VCMIDLTool"/>
-			<Tool
-				Name="VCPostBuildEventTool"
-				CommandLine="copy $(OutDir)\$(TargetFileName) ..\..\..\Samples\Common\bin\$(ConfigurationName)"/>
-			<Tool
-				Name="VCPreBuildEventTool"/>
-			<Tool
-				Name="VCPreLinkEventTool"/>
-			<Tool
-				Name="VCResourceCompilerTool"/>
-			<Tool
-				Name="VCWebServiceProxyGeneratorTool"/>
-			<Tool
-				Name="VCWebDeploymentTool"/>
-		</Configuration>
-	</Configurations>
-	<Files>
-		<Filter
-			Name="Source Files"
-			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm">
-			<File
-				RelativePath="..\src\OgreBspLevel.cpp">
-			</File>
-			<File
-				RelativePath="..\src\OgreBspNode.cpp">
-			</File>
-			<File
-				RelativePath="..\src\OgreBspResourceManager.cpp">
-			</File>
-			<File
-				RelativePath="..\src\OgreBspSceneManager.cpp">
-			</File>
-			<File
-				RelativePath="..\misc\OgreBspSceneManager.def">
-			</File>
-			<File
-				RelativePath="..\src\OgreBspSceneManagerDll.cpp">
-			</File>
-			<File
-				RelativePath="..\src\OgreBspSceneNode.cpp">
-			</File>
-			<File
-				RelativePath="..\src\OgreQuake3Level.cpp">
-			</File>
-			<File
-				RelativePath="..\src\OgreQuake3Shader.cpp">
-			</File>
-			<File
-				RelativePath="..\src\OgreQuake3ShaderManager.cpp">
-			</File>
-		</Filter>
-		<Filter
-			Name="Header Files"
-			Filter="h;hpp;hxx;hm;inl;inc">
-			<File
-				RelativePath="..\include\OgreBspLevel.h">
-			</File>
-			<File
-				RelativePath="..\include\OgreBspNode.h">
-			</File>
-			<File
-				RelativePath="..\include\OgreBspPrerequisites.h">
-			</File>
-			<File
-				RelativePath="..\include\OgreBspResourceManager.h">
-			</File>
-			<File
-				RelativePath="..\include\OgreBspSceneManager.h">
-			</File>
-			<File
-				RelativePath="..\include\OgreBspSceneNode.h">
-			</File>
-			<File
-				RelativePath="..\include\OgreQuake3Level.h">
-			</File>
-			<File
-				RelativePath="..\include\OgreQuake3Shader.h">
-			</File>
-			<File
-				RelativePath="..\include\OgreQuake3ShaderManager.h">
-			</File>
-			<File
-				RelativePath="..\include\OgreQuake3Types.h">
-			</File>
-		</Filter>
-		<Filter
-			Name="Resource Files"
-			Filter="rc;ico;cur;bmp;dlg;rc2;rct;bin;rgs;gif;jpg;jpeg;jpe">
-		</Filter>
-	</Files>
-	<Globals>
-	</Globals>
-</VisualStudioProject>
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/world.cfg
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/world.cfg	(revision 12)
+++ 	(revision )
@@ -1,6 +1,0 @@
-HeightMap=2049x2049_map.png
-Scale.x=2.0
-Scale.y=0.6
-Scale.z=2.0
-WorldTexture=terrain_texture.jpg
-DetailTexture=terrain_detail.jpg
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/ogre.cfg
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/ogre.cfg	(revision 12)
+++ 	(revision )
@@ -1,6 +1,0 @@
-Render System	OpenGL Rendering Subsystem
-Colour Depth	32
-Display Frequency	60
-Full Screen	No
-VSync	No
-Video Mode	1024 x 768
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/OgreLeaks.log
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/OgreLeaks.log	(revision 12)
+++ 	(revision )
@@ -1,11 +1,0 @@
- ---------------------------------------------------------------------------------------------------------------------------------- 
-|                                          Memory leak report for:  02/02/2005 18:29:00                                            |
- ---------------------------------------------------------------------------------------------------------------------------------- 
-
-
-1 memory leak found:
-
-Alloc.   Addr       Size       Addr       Size                        BreakOn BreakOn              
-Number Reported   Reported    Actual     Actual     Unused    Method  Dealloc Realloc Allocated by 
------- ---------- ---------- ---------- ---------- ---------- -------- ------- ------- --------------------------------------------------- 
-000724 0x00BDD2F0 0x0000014C 0x00BDD2E0 0x0000016C 0x00000000 new         N       N    filesystemfactory.cpp(29) Ogre::FileSystemFactory::createObj
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.dsw
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/Plugin_OcclusionCullingSceneManager.dsw	(revision 14)
+++ 	(revision )
@@ -1,29 +1,0 @@
-Microsoft Developer Studio Workspace File, Format Version 6.00
-# WARNING: DO NOT EDIT OR DELETE THIS WORKSPACE FILE!
-
-###############################################################################
-
-Project: "Plugin_OcclusionCullingSceneManager"=.\Plugin_OcclusionCullingSceneManager.dsp - Package Owner=<4>
-
-Package=<5>
-{{{
-}}}
-
-Package=<4>
-{{{
-}}}
-
-###############################################################################
-
-Global:
-
-Package=<5>
-{{{
-}}}
-
-Package=<3>
-{{{
-}}}
-
-###############################################################################
-
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/terrain.cfg
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/terrain.cfg	(revision 12)
+++ 	(revision )
@@ -1,73 +1,0 @@
-# The main world texture (if you wish the terrain manager to create a material for you)
-WorldTexture=terrain_texture.jpg
-
-# The detail texture (if you wish the terrain manager to create a material for you)
-DetailTexture=terrain_detail.jpg
-
-#number of times the detail texture will tile in a terrain tile
-DetailTile=3
-
-# Heightmap source
-PageSource=Heightmap
-
-# Heightmap-source specific settings
-Heightmap.image=terrain.png
-
-# If you use RAW, fill in the below too
-# RAW-specific setting - size (horizontal/vertical)
-#Heightmap.raw.size=513
-# RAW-specific setting - bytes per pixel (1 = 8bit, 2=16bit)
-#Heightmap.raw.bpp=2
-# Use this if you want to flip the terrain (eg Terragen exports raw upside down)
-#Heightmap.flip=true
-
-# How large is a page of tiles (in vertices)? Must be (2^n)+1
-PageSize=513
-
-# How large is each tile? Must be (2^n)+1 and be smaller than PageSize
-TileSize=65
-
-# The maximum error allowed when determining which LOD to use
-MaxPixelError=3
-
-# The size of a terrain page, in world units
-PageWorldX=1500
-PageWorldZ=1500
-# Maximum height of the terrain 
-MaxHeight=100
-
-# Upper LOD limit
-MaxMipMapLevel=5
-
-#VertexNormals=yes
-#VertexColors=yes
-#UseTriStrips=yes
-
-# Use vertex program to morph LODs, if available
-VertexProgramMorph=yes
-
-# The proportional distance range at which the LOD morph starts to take effect
-# This is as a proportion of the distance between the current LODs effective range,
-# and the effective range of the next lower LOD
-LODMorphStart=0.2
-
-# This following section is for if you want to provide your own terrain shading routine
-# Note that since you define your textures within the material this makes the 
-# WorldTexture and DetailTexture settings redundant
-
-# The name of the vertex program parameter you wish to bind the morph LOD factor to
-# this is 0 when there is no adjustment (highest) to 1 when the morph takes it completely
-# to the same position as the next lower LOD
-# USE THIS IF YOU USE HIGH-LEVEL VERTEX PROGRAMS WITH LOD MORPHING
-#MorphLODFactorParamName=morphFactor
-
-# The index of the vertex program parameter you wish to bind the morph LOD factor to
-# this is 0 when there is no adjustment (highest) to 1 when the morph takes it completely
-# to the same position as the next lower LOD
-# USE THIS IF YOU USE ASSEMBLER VERTEX PROGRAMS WITH LOD MORPHING
-#MorphLODFactorParamIndex=4
-
-# The name of the material you will define to shade the terrain
-#CustomMaterialName=TestTerrainMaterial
-
-
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/OgreMemory.log
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/OgreMemory.log	(revision 12)
+++ 	(revision )
@@ -1,29 +1,0 @@
---------------------------------------------------------------------------------
-
-      OgreMemory.log - Memory logging file created on Wed Feb 02 18:28:57 2005
-
---------------------------------------------------------------------------------
-
-This file contains a log of all memory operations performed during the last run.
-
-Interrogate this file to track errors or to help track down memory-related
-issues. You can do this by tracing the allocations performed by a specific owner
-or by tracking a specific address through a series of allocations and
-reallocations.
-
-There is a lot of useful information here which, when used creatively, can be
-extremely helpful.
-
-Note that the following guides are used throughout this file:
-
-   [!] - Error
-   [+] - Allocation
-   [~] - Reallocation
-   [-] - Deallocation
-   [I] - Generic information
-   [F] - Failure induced for the purpose of stress-testing your application
-   [D] - Information used for debugging this memory manager
-
-...so, to find all errors in the file, search for "[!]"
-
---------------------------------------------------------------------------------
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/quake3settings.cfg
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/quake3settings.cfg	(revision 12)
+++ 	(revision )
@@ -1,2 +1,0 @@
-Pak0Location: D:\Q3Ademo\demoq3\pak0.pk3
-Map: maps/q3dm1.bsp
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/resources.cfg
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/resources.cfg	(revision 12)
+++ 	(revision )
@@ -1,15 +1,0 @@
-FileSystem=../../../Media
-FileSystem=../../../Media/fonts
-FileSystem=../../../Media/materials/programs
-FileSystem=../../../Media/materials/scripts
-FileSystem=../../../Media/materials/textures
-FileSystem=../../../Media/models
-FileSystem=../../../Media/overlays
-FileSystem=../../../Media/particle
-Zip=../../../Media/packs/cubemap.zip
-Zip=../../../Media/packs/cubemapsJS.zip
-Zip=../../../Media/packs/dragon.zip
-Zip=../../../Media/packs/fresneldemo.zip
-Zip=../../../Media/packs/OgreCore.zip
-Zip=../../../Media/packs/ogretestmap.zip
-Zip=../../../Media/packs/skybox.zip
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/Ogre.log
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/Ogre.log	(revision 12)
+++ 	(revision )
@@ -1,77 +1,0 @@
-18:28:57: Loading library OgrePlatform.dll
-18:28:57: ArchiveFactory for archive type Zip registered.
-18:28:57: Loading library .\RenderSystem_Direct3D7
-18:28:57: Direct3D7 Rendering Subsystem created.
-18:28:57: ----- DirectDraw Detection Starts
-18:28:57: Detected DirectDraw driver Primary Display Driver.
-
-18:28:57: ----- DirectDraw Detection Ends
-18:28:57: Loading library .\RenderSystem_Direct3D9
-18:28:57: D3D9 : Direct3D9 Rendering SubSystem created.
-18:28:57: D3D9: Driver Detection Starts
-18:28:57: D3D9: Driver Detection Ends
-18:28:57: Loading library .\RenderSystem_GL
-18:28:57: OpenGL Rendering Subsystem created.
-18:28:57: Loading library .\Plugin_FileSystem
-18:28:57: ArchiveFactory for archive type FileSystem registered.
-18:28:57: Loading library .\Plugin_ParticleFX
-18:28:57: Particle Emitter Type 'Point' registered
-18:28:57: Particle Emitter Type 'Box' registered
-18:28:57: Particle Emitter Type 'Ellipsoid' registered
-18:28:57: Particle Emitter Type 'Cylinder' registered
-18:28:57: Particle Emitter Type 'Ring' registered
-18:28:57: Particle Emitter Type 'HollowEllipsoid' registered
-18:28:57: Particle Affector Type 'LinearForce' registered
-18:28:57: Particle Affector Type 'ColourFader' registered
-18:28:57: Particle Affector Type 'ColourFader2' registered
-18:28:57: Particle Affector Type 'ColourImage' registered
-18:28:57: Particle Affector Type 'ColourInterpolator' registered
-18:28:57: Particle Affector Type 'Scaler' registered
-18:28:57: Particle Affector Type 'Rotator' registered
-18:28:57: Loading library .\Plugin_OctreeSceneManager
-18:28:57: TerrainSceneManager: Registered a new PageSource for type Heightmap
-18:28:57: Loading library .\Plugin_GuiElements
-18:28:57: GuiElementFactory for type Cursor registered.
-18:28:57: GuiElementFactory for type Panel registered.
-18:28:57: GuiElementFactory for type BorderPanel registered.
-18:28:57: GuiElementFactory for type TextArea registered.
-18:28:57: GuiElementFactory for type TextBox registered.
-18:28:57: GuiElementFactory for type Button registered.
-18:28:57: GuiElementFactory for type BorderButton registered.
-18:28:57: GuiElementFactory for type List registered.
-18:28:57: GuiElementFactory for type ScrollBar registered.
-18:28:57: GuiElementFactory for type PopupMenu registered.
-18:28:57: GuiElementFactory for type TTY registered.
-18:28:57: Loading library .\Plugin_NatureSceneManager
-18:28:57: Loading library .\Plugin_CgProgramManager
-18:28:57: Loading library .\Plugin_OcclusionCullingSceneManager
-18:28:57: *-*-* OGRE Initialising
-18:28:57: *-*-* Version 0.15.2 (Hastur)
-18:28:57: An exception has been thrown!
-
------------------------------------
-Details:
------------------------------------
-Error #: 7
-Function: FileSystem::load
-Description: Cannot find folder ../../../Media. 
-File: d:\ogrenew\plugins\filesystem\src\filesystem.cpp
-Line: 423
-Stack unwinding: <<beginning of stack>>
-18:29:00: *-*-* OGRE Shutdown
-18:29:00: Unloading library .\Plugin_OcclusionCullingSceneManager
-18:29:00: Unloading library .\Plugin_CgProgramManager
-18:29:00: Unloading library .\Plugin_NatureSceneManager
-18:29:00: Unloading library .\Plugin_GuiElements
-18:29:00: Unloading library .\Plugin_OctreeSceneManager
-18:29:00: Unloading library .\Plugin_ParticleFX
-18:29:00: Unloading library .\Plugin_FileSystem
-18:29:00: *** Stopping Win32GL Subsystem ***
-18:29:00: Unloading library .\RenderSystem_GL
-18:29:00: D3D9 : Shutting down cleanly.
-18:29:00: D3D9 : Direct3D9 Rendering SubSystem destroyed.
-18:29:00: Unloading library .\RenderSystem_Direct3D9
-18:29:00: *-*-* Direct3D Subsystem shutting down cleanly.
-18:29:00: Direct3D7 Rendering Subsystem destroyed.
-18:29:00: Unloading library .\RenderSystem_Direct3D7
-18:29:00: Unloading library OgrePlatform.dll
Index: trunk/VUT/OcclusionCullingSceneManager/scripts/media.cfg
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/scripts/media.cfg	(revision 12)
+++ 	(revision )
@@ -1,19 +1,0 @@
-Mesh=ogrehead.mesh
-Mesh=geosphere4500.mesh
-Mesh=razor.mesh
-Mesh=geosphere12500.mesh
-Mesh=knot.mesh
-Mesh=geosphere19220.mesh
-Mesh=RZR-002.mesh
-Mesh=geosphere1000.mesh
-Mesh=geosphere8000.mesh
-Mesh=sphere.mesh
-
-CubeMap=cubescene.jpg
-CubeMap=early_morning.jpg
-CubeMap=cubemap.jpg
-CubeMap=morning.jpg
-CubeMap=cloudy_noon.jpg
-CubeMap=evening.jpg
-CubeMap=stormy.jpg
-CubeMap=stevecube.jpg
Index: trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingSceneManagerDll.cpp
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingSceneManagerDll.cpp	(revision 12)
+++ trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingSceneManagerDll.cpp	(revision 16)
@@ -26,5 +26,5 @@
 #include "OgreOcclusionCullingSceneManager.h"
 #include "OgreRoot.h"
-//#include "windows.h"
+#include <windows.h>
 
 namespace Ogre {
@@ -36,10 +36,10 @@
         // Create new scene manager
         occlusionPlugin = new OcclusionCullingSceneManager();
+		
+		// Register
+        Root::getSingleton().setSceneManager(ST_INTERIOR, occlusionPlugin);
+		//Root::getSingleton().setSceneManager(ST_GENERIC, occlusionPlugin);
 
-        // Register
-        Root::getSingleton().setSceneManager(ST_INTERIOR, occlusionPlugin);
-		//Root::getSingleton().setSceneManager(ST_GENERIC, bspPlugin);
-		//printf("registered my plugin!!\n");
-		//MessageBox( NULL, "myplugin", "this is my plugin", MB_OK | MB_ICONERROR | MB_TASKMODAL);
+		MessageBox( NULL, "myplugin registered", "this is my plugin", MB_OK | MB_ICONERROR | MB_TASKMODAL);
     }
     extern "C" void dllStopPlugin(void)
Index: trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingSceneManager.cpp
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingSceneManager.cpp	(revision 12)
+++ trunk/VUT/OcclusionCullingSceneManager/src/OgreOcclusionCullingSceneManager.cpp	(revision 16)
@@ -2,4 +2,5 @@
 #include "OgreMath.h"
 #include "OgreIteratorWrappers.h"
+#include <windows.h>
 
 namespace Ogre {
@@ -8,5 +9,5 @@
 	OcclusionCullingSceneManager::OcclusionCullingSceneManager(): 
 	mFrameID(1)
-	{
+	{		
 	}
 
@@ -17,5 +18,6 @@
 		//mDistanceQueue.push(mSceneRoot);
 		//Preprocess();
-
+		//printf("registered my plugin!!\n");
+		//MessageBox( NULL, "myplugin", "this is my plugin", MB_OK | MB_ICONERROR | MB_TASKMODAL);
 		renderCullFrustum();
 
Index: trunk/VUT/OcclusionCullingSceneManager/src/Makefile.am
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/src/Makefile.am	(revision 12)
+++ trunk/VUT/OcclusionCullingSceneManager/src/Makefile.am	(revision 16)
@@ -1,17 +1,11 @@
-INCLUDES = $(STLPORT_CFLAGS) -I$(top_srcdir)/PlugIns/BSPSceneManager/include -I$(top_srcdir)/OgreMain/include
+INCLUDES = $(STLPORT_CFLAGS) -I$(top_srcdir)/PlugIns/OcclusionCullingSceneManager/include -I$(top_srcdir)/OgreMain/include
 
 pkglib_PROGRAMS = Plugin_BSPSceneManager.so
 
-Plugin_BSPSceneManager_so_SOURCES = OgreBspLevel.cpp \
-                             OgreBspNode.cpp \
-                             OgreBspResourceManager.cpp \
-                             OgreBspSceneManager.cpp \
-                             OgreBspSceneManagerDll.cpp \
-							 OgreBspSceneNode.cpp \
-                             OgreQuake3ShaderManager.cpp \
-                             OgreQuake3Shader.cpp \
-                             OgreQuake3Level.cpp
-
-
-Plugin_BSPSceneManager_so_LDFLAGS = $(SHARED_FLAGS) -L$(top_srcdir)/OgreMain/src
-Plugin_BSPSceneManager_so_LDADD = -lOgreMain
+Plugin_OcclusionCullingSceneManager_so_SOURCES = OgreBspLevel.cpp \
+                             OcclusionCullingResourceManager.cpp \
+                             OcclusionCullingSceneManager.cpp \
+                             OcclusionCullingSceneManagerDll.cpp
+					
+Plugin_OcclusionCullingSceneManager_so_LDFLAGS = $(SHARED_FLAGS) -L$(top_srcdir)/OgreMain/src
+Plugin_OcclusionCullingSceneManager_so_LDADD = -lOgreMain
Index: trunk/VUT/OcclusionCullingSceneManager/TestCulling/TestCulling.vcproj
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/TestCulling/TestCulling.vcproj	(revision 13)
+++ trunk/VUT/OcclusionCullingSceneManager/TestCulling/TestCulling.vcproj	(revision 16)
@@ -13,6 +13,6 @@
 		<Configuration
 			Name="Debug|Win32"
-			OutputDirectory="Debug"
-			IntermediateDirectory="Debug"
+			OutputDirectory="..\bin\$(ConfigurationName)"
+			IntermediateDirectory="..\obj\$(ConfigurationName)"
 			ConfigurationType="1"
 			CharacterSet="2"
@@ -35,5 +35,5 @@
 				Name="VCLinkerTool"
 				AdditionalDependencies="OGREMain_d.LIB"
-				OutputFile="$(OGRE_PATH)\Common\Bin\Debug\TestCulling.exe"
+				OutputFile="$(OGRE_PATH)\Samples\Common\Bin\Debug\TestCulling.exe"
 				LinkIncremental="2"
 				AdditionalLibraryDirectories="$(OGRE_PATH)\OgreMain\Lib\Debug"
@@ -120,7 +120,4 @@
 			Filter="cpp;c;cxx;def;odl;idl;hpj;bat;asm;asmx"
 			UniqueIdentifier="{4FC737F1-C7A5-4376-A066-2A32D752A2FF}">
-			<File
-				RelativePath=".\TestCullingApplication.cpp">
-			</File>
 		</Filter>
 		<Filter
Index: trunk/VUT/OcclusionCullingSceneManager/TestCulling/TestCullingApplication.cpp
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/TestCulling/TestCullingApplication.cpp	(revision 12)
+++ trunk/VUT/OcclusionCullingSceneManager/TestCulling/TestCullingApplication.cpp	(revision 16)
@@ -30,9 +30,9 @@
     TestCullingApplication app;
 
-    try {
+	try {
         app.go();
     } catch( Ogre::Exception& e ) {
         MessageBox( NULL, e.getFullDescription().c_str(), "An exception has occured!", MB_OK | MB_ICONERROR | MB_TASKMODAL);
-    }
+    }	
 
     return 0;
Index: trunk/VUT/OcclusionCullingSceneManager/TestCulling/TestCullingApplication.h
===================================================================
--- trunk/VUT/OcclusionCullingSceneManager/TestCulling/TestCullingApplication.h	(revision 12)
+++ trunk/VUT/OcclusionCullingSceneManager/TestCulling/TestCullingApplication.h	(revision 16)
@@ -86,5 +86,6 @@
     void chooseSceneManager(void)
     {
-        mSceneMgr = mRoot->getSceneManager(ST_INTERIOR);
+    //    mSceneMgr = mRoot->getSceneManager(ST_GENERIC);
+		mSceneMgr = mRoot->getSceneManager(ST_INTERIOR);
     }
 	/*